%{
  open Lexing
  open Ast_program
%}
     
%token LPAR RPAR
%token LSEND RSEND
%token COMP EMPTY
%token <Ast_program.pvar> IDENT
%token DOT
%token EOF

%start <Ast_program.pprog> init

%left DOT
%left COMP

%%

init:
| p = pprog; EOF
  { p }


pprog:
| a = IDENT ; LSEND ; RSEND
  { PSend (String.capitalize_ascii a, PZero) }
| a = IDENT ; LSEND ; p = pprog ; RSEND
  { PSend (String.capitalize_ascii a, p) }
| a = IDENT ; DOT ; p = pprog
  { PRec (String.capitalize_ascii a, "", p) }
| a = IDENT ; LPAR ; x = IDENT ; RPAR ; DOT ; p = pprog
  { PRec (String.capitalize_ascii a, String.uncapitalize_ascii x, p) }
| p = pprog ; COMP ; q = pprog
  { PComp (p,q) }
| EMPTY
  { PZero }
| x = IDENT
  { PExe (String.uncapitalize_ascii x) }
| LPAR ; p = pprog ; RPAR
  { p }

